﻿using System;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;

namespace ABFUpload.Samples
{
    public class ExampleRequest
    {
        public void SendFile()
        {
            string filePath = @"C:\Users\<path>\<to>\<file.zip>"; // File to upload
            string apikey = ""; // The apikey of the project

            string url = "http://upload.swing.eu/api/projectupload"; // The upload url
            string boundary = "BoundaryToken123456";
            string FileName = Path.GetFileName(filePath);

            HttpResponseMessage response;

            using (var handler = new HttpClientHandler())
            using (var client = new HttpClient(handler))
            using (var form = new MultipartFormDataContent(boundary))
            using (var stream = new MemoryStream(File.ReadAllBytes(filePath)))
            {
                var fileContent = new StreamContent(stream);
                fileContent.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data")
                {
                    FileName = "\"" + Path.GetFileName(FileName) + "\""
                };
                fileContent.Headers.ContentType = new MediaTypeHeaderValue("application/octet-stream");

                form.Headers.Remove("Content-Type");
                form.Headers.TryAddWithoutValidation("Content-Type", "multipart/form-data; boundary=" + boundary);
                form.Add(fileContent);
                form.Add(new StringContent(apikey), "apikey");

                response = client.PostAsync(url, form).Result;
            }

            if (response.IsSuccessStatusCode)
                Console.WriteLine("File uploaded");
            else
                Console.WriteLine("Server returned error ({0}) - {1}", response.StatusCode, response.Content.ReadAsStringAsync().Result);

            Console.ReadLine();
        }
    }
}